明经CAD社区

 找回密码
 注册

扫一扫,访问微社区

QQ登录

只需一步,快速开始

查看: 1418|回复: 12

【几乎解决】求可以选中多个图层所有元素的插件

[复制链接]
发表于 2014-12-12 10:39 | 显示全部楼层 |阅读模式
本帖最后由 不来白不来 于 2014-12-12 15:40 编辑

比如在图纸中选中两个两条线a,b,分别位于A,B图层;
执行命令;
自动选中A,B图层所有元素。
找了好几个插件,都没有这样的功能。

-------------------------------------------------------
在外网找到了一个,输入命令sellay或是sellays,然后单选或多选元素,确定,然后就会自动将已选中的元素所在图层的所有元素全部选中。
但是有一个问题,比如我在0图层新建了一个块A,把它移到1图层,用这个命令的话选中的是0图层的所有元素(理应选择图块A所在的1图层)。求解决
[code="lisp] ;(C) 2008 CAD Studio -
;select objects on a picked layer(s)

(defun C:SELLAY ( / e ss i)
(setq i (ssget "_I"))
(setq e (nentsel "Select entity on a layer: "))
(if e (setq ss (ssget (if i "_I" "_X") (list(cons 8 (cdr (assoc 8 (entget (car e)))))))))
(if (zerop (getvar "CMDACTIVE"))
  (progn (sssetfirst ss ss)(princ "Use 'P' for this selection set: ")(princ))
   ss
)
)

(defun C:SELLAYS ( / e lay ss layl i)
(setq i (ssget "_I"))
(setq layl ""  ss (ssadd))
(while (setq e (nentsel "\nSelect entity on a layer <exit>: "))
  (setq layl (strcat layl "," (cdr (assoc 8 (entget (car e))))))
  (princ (substr layl 2))
);while
(setq layl (substr layl 2))
(if (> layl "") (setq ss (ssget (if i "_I" "_X") (list (cons 8 layl)))))
(if (zerop (getvar "CMDACTIVE"))
  (progn (sssetfirst ss ss)(princ "Use 'P' for this selection set: ")(princ))
   ss
)
)

(princ "\nXanadu SELLAY + SELLAYS commands loaded.")(princ)[/code]
居然被我找到一个更好用的,见三楼,命令是sel。

本帖子中包含更多资源

您需要 登录 才可以下载或查看,没有帐号?注册

x
 楼主| 发表于 2014-12-12 15:29 | 显示全部楼层
在选中的时候不能显示成虚线,不能框选,求高手完善
 楼主| 发表于 2014-12-12 15:38 | 显示全部楼层
我去,居然被我找到另一个更好的脚本[code="lisp] (defun c:sel (/ ss i layer lst)
  (if (setq ss (ssget))
    (progn
      (repeat (setq i (sslength ss))
        (if (not (member (setq layer (cdr (assoc 8 (entget (ssname ss (setq i (1- i))))))) lst))
          (setq lst (cons "," (cons layer lst)))
        )
      )
      (sssetfirst nil (ssget "_A" (list (cons 8 (apply 'strcat (cdr lst))))))
    )
  )
  (princ)
)[/code]

本帖子中包含更多资源

您需要 登录 才可以下载或查看,没有帐号?注册

x
发表于 2015-1-26 23:45 | 显示全部楼层
不来白不来 发表于 2014-12-12 15:38
我去,居然被我找到另一个更好的脚本

非常感谢,也正是我非常想要的,以前一直用快速选择!!!
发表于 2015-9-4 17:14 | 显示全部楼层
这尼玛不顶不行啊!太感谢了。
发表于 2017-11-8 10:13 | 显示全部楼层
不错,可以快速选择多个图层
发表于 2017-11-9 08:53 | 显示全部楼层
好东西 学习下
发表于 2017-11-14 14:21 | 显示全部楼层

好东西 学习下
发表于 2017-12-25 13:06 | 显示全部楼层

好东西 学习下
发表于 2017-12-27 18:03 | 显示全部楼层
感谢分享学习!!!!
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号  
©2000-2017 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2018-10-17 05:48 , Processed in 0.179941 second(s), 28 queries , Gzip On.

Powered by Discuz! X3.3

© 2001-2013 Comsenz Inc.

快速回复 返回顶部 返回列表